print-variables:
  extends:
    - .variables
    - .tags-docker
  stage: pre-build
  image: ${IMAGE_DOCKER_STABLE}
  rules: {@inject-rules:print_variables:.rules-always}
  variables:
    PYTHONPATH: .cicd_scripts
  script:
    - /bin/bash .cicd_scripts/gitlab/pipeline/list_pipeline_variables.sh

export-cleanup-artifacts:
  extends:
    - .variables
    - .tags-docker
  stage: pre-build
  image: ${IMAGE_DOCKER_STABLE}
  rules: {@inject-rules:export_cleanup_artifacts:.rules-always}
  variables:
    PYTHONPATH: .cicd_scripts
  script:
    - /bin/bash .cicd_scripts/gitlab/pipeline/prepare_cleanup_artifacts.sh
  artifacts:
    # Note!
    # This will always export the contents of the repository **and** the .cicd_scripts which is added to it
    # via artifact from initialize/copy-cicd-scripts job. This way we can do `rm -rf ./` in cleanup/destroy jobs
    # and replace the content of build folder with the files from ZIP.
    paths:
      - "${ARTIFACT_ALL_SOURCES}"
    expire_in: 30 days

.docker-images:
  extends:
    - .variables
    - .tags-docker
  stage: pre-build
  image: ${IMAGE_DOCKER_STABLE}
  services:
    - name: ${IMAGE_DOCKER_DIND}
      alias: docker


docker-images-build:
  extends:
    - .docker-images
  rules: {@inject-rules:docker_images_build:.rules-when-docker-images-build-required}
  script:
    - /bin/bash .cicd_scripts/execute/docker_images_build.sh

docker-images-pull:
  extends:
    - .docker-images
  rules: {@inject-rules:docker_images_pull:.rules-when-docker-images-build-not-required}
  script:
    - /bin/bash .cicd_scripts/execute/docker_images_pull.sh